<template lang="pug">
#app
  .hero.is-fullheight.is-flex.is-flex-direction-column.is-justify-content-flex-start
    .bg
    Header
    router-view.is-flex-grow-1
    Footer
    notifications
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { VModel, Prop, Watch } from "vue-property-decorator";
import { RouteMeta } from "vue-router";

@Component({
  components: {
    Header: () => import("./components/Header.vue"),
    Footer: () => import("./components/Footer.vue"),
  },
})
export default class App extends Vue {
  private atAccountChange = false;

  get isAuthorized() {
    return this.$store.getters["Web3Module/isAuthorized"];
  }

  get hasStoredAuthData() {
    return this.$store.getters["Web3Module/hasStoredData"];
  }

  @Watch(`$route`)
  route(to: RouteMeta) {
    const isDashboardRoute = to.path.match(/profile|admin/) !== null;
    const isLoginRoute = to.path.match(/login/) !== null;
    if (
      isDashboardRoute &&
      !this.isAuthorized &&
      !this.atAccountChange
    ) {
      this.$router.push({ name: "Login" });
    } else if (isLoginRoute && this.isAuthorized) {
      this.$router.push({ name: "Profile" });
    }
  }

  async onAccountChanged(newAccount: string) {
    console.log(newAccount);
    this.atAccountChange = true;
    await this.init();
    await this.$store.dispatch("Web3Module/reset", true);
    await this.connectWeb3(this.$store.getters["Web3Module/providerId"]);
    this.atAccountChange = false;
    return this.$notify({
      title: "Account changed",
      text: newAccount,
      type: "success",
    });
  }

  async onChainIdChanged(newChainId: number) {
    console.log(newChainId, this.$store.getters["Web3Module/targetChainId"]);
    if (newChainId !== this.$store.getters["Web3Module/targetChainId"]) {
      this.$notify({
        title: "Bad network",
        text: "Please choose BNB Smart Chain network",
        type: "error",
      });
    }
  }

  async connectWeb3(id: "injected" | "walletconnect") {
    await this.$store.dispatch("Web3Module/connect", {
      id,
      onAccountChangedCallback: (newAccount: string) => {
        this.onAccountChanged(newAccount);
      },
      onChainIdChangedCallback: (newChainId: number) => {
        this.onChainIdChanged(newChainId);
      },
      onConnectCallback: async () => {
        await this.init();
        if (this.$route.path.match(/login/)) {
          this.$router.push({ name: "Profile" })
        }
        // if (!this.$route.path.match(/profile|admin/))
        //   this.$router.push({ name: "ProfileStatistics" });
      },
    });
  }

  async init() {
    this.$store.dispatch(
      "UserModule/getUser",
      this.$store.getters["Web3Module/account"]
    );
    this.$store.dispatch("PoolModule/getMemePool");
  }

  async mounted() {
    this.$store.dispatch("Web3Module/onReset", (preventRedirect) => {
      if (!preventRedirect) this.$router.push({ name: "Login" });
    });

    const canConnect =
      this.$store.getters["Web3Module/chainId"] ===
        this.$store.getters["Web3Module/targetChainId"] &&
      this.$store.getters["Web3Module/account"];
    if (!canConnect) return;
    await this.connectWeb3(this.$store.getters["Web3Module/providerId"]);
  }
}
</script>

<style lang="scss" scoped>
#app {
  min-width: $body-min-width;
  background: linear-gradient(0deg, #17131c, #17131c), #0c0f14;
}

.bg {
  width: 100%;
  height: 1400px;
  // height: 100%;
  max-height: 100%;
  margin: 0 auto;
  background: linear-gradient(180deg, rgba(23, 19, 28, 0) 79.39%, #17131c 100%),
    radial-gradient(
      43.18% 61.28% at -15.96% 49.25%,
      rgba(91, 145, 57, 0.2867) 0%,
      rgba(92, 145, 56, 0) 100%
    ),
    radial-gradient(
      56.36% 36.62% at 72.04% 66.02%,
      rgba(92, 44, 37, 0.3599) 0%,
      rgba(22, 19, 28, 0) 100%
    ),
    radial-gradient(
      91.57% 28.2% at 4.18% 7.06%,
      rgba(92, 44, 37, 0.3599) 0%,
      rgba(22, 19, 28, 0) 100%
    ),
    url("@/assets/img/bg.webp");
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  z-index: 0;
}

.is-fullheight {
  overflow: hidden;
}
</style>